/* pam_strerror.c */

#include "pam_private.h"

const char *pam_strerror(int errnum)
{
    switch (errnum) {
    case PAM_SUCCESS:
	return "Success";
    case PAM_ABORT:
	return "Critical Error - Aborted";
    case PAM_OPEN_ERR:
	return "dlopen() failure";
    case PAM_SYMBOL_ERR:
	return "Symbol not found";
    case PAM_SERVICE_ERR:
	return "Error in service module";
    case PAM_SYSTEM_ERR:
	return "System error";
    case PAM_BUF_ERR:
	return "Memory buffer error";
    case PAM_PERM_DENIED:
	return "Permission denied";
    case PAM_AUTH_ERR:
	return "Authentication failure";
    case PAM_CRED_INSUFFICIENT:
	return "Cannot access authentication data "
	    "due to insufficient credentials";
    case PAM_AUTHINFO_UNAVAIL:
	return "Underlying authentication service "
	    "cannot retrieve authenticaiton "
	    "information";
    case PAM_USER_UNKNOWN:
	return "User not known to the underlying "
	    "authenticaiton module ";
    case PAM_MAXTRIES:
	return "An authentication service has "
	    "maintained a retry count which has "
	    "been reached.  No further retries "
	    "should be attempted";
    case PAM_AUTHTOKEN_REQD:
	return "New authentication token required. "
	    "This is normally returned if the "
	    "machine security policies require "
	    "that the password should be changed "
	    "beccause the password is NULL or it "
	    "has aged";
    case PAM_ACCT_EXPIRED:
	return "User account has expired";
    case PAM_SESSION_ERR:
	return "Cannot make/remove an entry for "
	    "the specified session";
    case PAM_CRED_UNAVAIL:
	return "Underlying authentication service "
	    "cannot retrieve user credentials";
    case PAM_CRED_EXPIRED:
	return "User credentials expired";
    case PAM_CRED_ERR:
	return "Failure setting user credentials";
    case PAM_NO_MODULE_DATA:
	return "No module specific data is present";
    case PAM_BAD_ITEM:
	return "Bad item passed to pam_*_item()";

/* added by AGM:1996/2/8 */

    case PAM_CONV_ERR:
	return "Conversation error";
    case PAM_AUTHTOK_ERR:
	return "Authentication token manipulation error";
    case PAM_AUTHTOK_RECOVER_ERR:
	return "Authentication information cannot be recovered";
    case PAM_AUHTOK_LOCK_BUSY:
	return "Authentication token lock busy";
    case PAM_AUTHTOK_DISABLE_AGING:
	return "Authentication token aging disabled";
    case PAM_TRY_AGAIN:
	return "Preliminary check by password service";
    case PAM_IGNORE:
	return "Ingore underlying account module regardless "
	    "of whether the control flag is required, "
	    "optional, or sufficient";

/* end of addition AGM */

    }

    return "Unknown PAM error";
}
